#!/bin/bash

ISPConfigVer="ISPConfig-3.1"
WD="/usr/share/${ISPConfigVer}"

ln -sf $WD/cron /usr/bin/cron

echo "################################################################################"
echo " Aplicando configuración de Dovecot"
ln -sf $WD/dovecot-sql.conf /etc/dovecot/dovecot-sql.conf
ln -sf /etc/dovecot/dovecot-sql.conf /etc/dovecot-sql.conf
#[ -f /etc/dovecot/conf.d/10-master.conf ] && { mv /etc/dovecot/conf.d/10-master.conf /etc/dovecot/conf.d/10-master.conf.ORIG; };
#ln -sf $WD/10-master.conf /etc/dovecot/conf.d/10-master.conf

echo "################################################################################"
echo " Activando Dovecot"
systemctl enable dovecot
systemctl start dovecot

echo "################################################################################"
echo " Desactivando Sendmail"
systemctl stop sendmail.service
systemctl disable sendmail.service

echo "################################################################################"
echo " Activando Postfix"
systemctl enable postfix.service
systemctl restart postfix.service

echo "################################################################################"
echo " Aplicando configuración de phpMyAdmin en Apache"
[ -f /etc/httpd/conf.d/phpMyAdmin.conf ] && { mv /etc/httpd/conf.d/phpMyAdmin.conf /etc/httpd/conf.d/phpMyAdmin.conf.ORIG; };
ln -sf $WD/phpMyAdmin.conf /etc/httpd/conf.d/phpMyAdmin.conf

echo "################################################################################"
echo " Aplicando configuración de phpMyAdmin"
[ -f /etc/phpMyAdmin/config.inc.php ] && { mv /etc/phpMyAdmin/config.inc.php /etc/phpMyAdmin/config.inc.php.ORIG; };
ln -sf $WD/pma-config.inc.php /etc/phpMyAdmin/config.inc.php

echo "################################################################################"
echo " Aplicando configuración de FreshClam"
[ -f /etc/freshclam.conf ] && { mv /etc/freshclam.conf /etc/freshclam.conf.ORIG; };
ln -sf $WD/freshclam.conf /etc/freshclam.conf

echo "################################################################################"
echo " Aplicando configuración de PHP"
[ -f /etc/php.ini ] && { mv /etc/php.ini /etc/php.ini.ORIG; };
ln -sf $WD/php.ini /etc/php.ini

echo "################################################################################"
echo " Aplicando configuración de PHP en Apache"
[ -f /etc/httpd/conf.d/php.conf ] && { mv /etc/httpd/conf.d/php.conf /etc/httpd/conf.d/php.conf.ORIG; };
ln -sf $WD/php.conf /etc/httpd/conf.d/php.conf

echo "################################################################################"
echo " Aplicando configuración de suPHP"
[ -f /etc/suphp.conf ] && { mv /etc/suphp.conf /etc/suphp.conf.ORIG; };
ln -sf $WD/suphp.conf /etc/suphp.conf

echo "################################################################################"
echo " Aplicando configuración de suPHP en Apache"
[ -f /etc/httpd/conf.d/mod_suphp.conf ] && { mv /etc/httpd/conf.d/mod_suphp.conf /etc/httpd/conf.d/mod_suphp.conf.ORIG; };
ln -sf $WD/mod_suphp.conf /etc/httpd/conf.d/mod_suphp.conf
chmod +s /usr/sbin/suphp

echo "################################################################################"
echo " Actualizando SA / AV y activando Amavis"
/usr/bin/sa-update
/usr/bin/freshclam
systemctl enable amavisd.service

echo "################################################################################"
echo " Activando PHP-FPM"
systemctl enable php-fpm.service
systemctl restart php-fpm.service

mkdir -p /etc/ssl/private/

echo "################################################################################"
echo " Generando Certificado para PureFTP"
openssl req -x509 -nodes -days 7300 -newkey rsa:2048 -keyout /etc/ssl/private/pure-ftpd.pem -out /etc/ssl/private/pure-ftpd.pem
chmod 600 /etc/ssl/private/pure-ftpd.pem

echo "################################################################################"
echo " Activando PureFTP"
systemctl enable pure-ftpd.service
systemctl restart pure-ftpd.service

echo "################################################################################"
echo " Aplicando configuración de BIND"
[ -f /etc/named.conf ] && { mv /etc/named.conf /etc/named.conf.ORIG; };
ln -sf $WD/named.conf /etc/named.conf
ln -sf $WD/named.conf.local /etc/named.conf.local

echo "################################################################################"
echo " Activando BIND"
systemctl enable named.service
systemctl start named.service

echo "################################################################################"
echo " Activando Fail2ban"
systemctl enable fail2ban.service
systemctl start fail2ban.service

ln -s $WD/aliases /var/lib/mailman/data/aliases

echo "################################################################################"
echo " Aplicando configuración de Roundcube en Apache"
[ -f /etc/httpd/conf.d/roundcubemail.conf ] && { mv /etc/httpd/conf.d/roundcubemail.conf /etc/httpd/conf.d/roundcubemail.conf.ORIG; };
ln -sf $WD/roundcubemail.conf /etc/httpd/conf.d/roundcubemail.conf

echo "################################################################################"
echo " Aplicando configuración de Roundcube"
[ -f /etc/roundcubemail/config.inc.php ] && { mv /etc/roundcubemail/config.inc.php /etc/roundcubemail/config.inc.php.ORIG; };
cp -a $WD/rc-config.inc.php /etc/roundcubemail/config.inc.php

echo "################################################################################"
echo " Importando BD de Roundcube"
echo " Ingresa la clave de MySQL: "
read MyPASSWD
/usr/bin/mysql --user=root --password=$MyPASSWD < $WD/rcm.sql

echo "################################################################################"
echo " Activando Apache"
systemctl enable httpd.service
systemctl restart httpd.service

echo "################################################################################"
echo " Reconfigurando Roundcube para Habilitar instalador"
HOSTNAME=`/usr/bin/cat /etc/hostname`
echo "\$config['enable_installer'] = true;" >> /etc/roundcubemail/config.inc.php
echo "  Listo!"
echo "  Ve a http://${HOSTNAME}/roundcubemail/installer y sigue el procedimiento"
echo "  Usuario y BD: roundcube / RoundCube123"
echo "  Presiona ENTER cuando esté instalado"
read

echo "################################################################################"
echo " Aplicando configuración de Roundcube en Apache"
[ -f /etc/httpd/conf.d/roundcubemail.conf ] && { mv /etc/httpd/conf.d/roundcubemail.conf /etc/httpd/conf.d/roundcubemail.conf.OLD; };
ln -sf $WD/roundcubemail.conf.local /etc/httpd/conf.d/roundcubemail.conf

echo "################################################################################"
echo " Reconfigurando Roundcube para DEShabilitar instalador"
rm -f /etc/roundcubemail/config.inc.php
ln -sf $WD/rc-config.inc.php /etc/roundcubemail/config.inc.php

echo "################################################################################"
echo " Reiniciando Apache"
systemctl restart httpd.service

echo "################################################################################"
echo " Corriendo instalandor de ISPConfig"
echo "################################################################################"

cd $WD/ispconfig3_install/install/
/usr/bin/php -q install.php

echo "################################################################################"
echo " Reconfigurando MailMan"
[ -f /etc/mailman/mm_cfg.py ] && { mv /etc/mailman/mm_cfg.py /etc/mailman/mm_cfg.py.OLD; };
ln -sf $WD/mm_cfg.py /etc/mailman/mm_cfg.py
#chown root.mailman /etc/mailman/mm_cfg.py

echo "################################################################################"
echo " Reiniciando Mailman"
systemctl restart mailman.service

rm -rf $WD/*.rpm

echo "################################################################################"
echo " Aplicando parche al ISPConfig"
[ -f /usr/local/ispconfig/server/scripts/ispconfig_patch ] && { mv /usr/local/ispconfig/server/scripts/ispconfig_patch /usr/local/ispconfig/server/scripts/ispconfig_patch.ORIG; };
ln -sf $WD/ispconfig_patch /usr/local/ispconfig/server/scripts/ispconfig_patch
ln -sf /usr/local/ispconfig/server/scripts/ispconfig_patch /usr/local/bin/ispconfig_patch
#cd /usr/local/ispconfig/server/scripts

echo "################################################################################"
echo " Reconfigurando Postfix"
[ -f /etc/postfix/master.cf ] && { mv /etc/postfix/master.cf /etc/postfix/master.cf.ORIG; };
ln -sf $WD/master.cf /etc/postfix/master.cf
[ -f /etc/postfix/main.cf ] && { mv /etc/postfix/main.cf /etc/postfix/main.cf.ORIG; };
ln -sf $WD/main.cf /etc/postfix/main.cf

echo "################################################################################"
echo " Generando Certificado para Postfix"
openssl req -new -outform PEM -out /etc/postfix/smtpd.cert -newkey rsa:2048 -nodes -keyout /etc/postfix/smtpd.key -keyform PEM -days 365 -x509

echo "################################################################################"
echo " Activando Postgrey"
systemctl enable postgrey
systemctl restart postgrey
echo "################################################################################"
echo " Reiniciando Postfix"
systemctl restart postfix
echo "################################################################################"
echo " Reiniciando Dovecot"
systemctl restart dovecot
echo "################################################################################"
echo " Deshabilitando Amavis"
systemctl stop amavisd
systemctl disable amavisd

echo "################################################################################"
echo " Busca suPHP y descoméntalo en /usr/local/ispconfig/server/conf/vhost.conf.master"
echo " Cópiale hacia el directorio conf-custom"
echo "################################################################################"
rm -f /usr/bin/cron
echo ""
echo "  LISTO!!!"
echo ""

exit 0
